#include "Sonar_SRF.h"

/*
*(uint8_t pinTrig, uint8_t pinEcho, bool interrupt)
*bool interrupt is ininfluence, but is necessary for chose the constructor that use interrupt
*/
void calcDist();

Sonar_SRF::Sonar_SRF(uint8_t pinTrig, uint8_t pinEcho, bool interrupt):
                            _pinTrig(pinTrig), _pinEcho(pinEcho){
                              pinMode (_pinTrig,OUTPUT);
                              pinMode (_pinEcho,INPUT);
                                attachInterrupt(0,calcDist,CHANGE);
                             
}


/*
*(uint8_t pinTrig, uint8_t pinEcho)
*utilized when the client attempt the change of level of duty cicle
*/


Sonar_SRF::Sonar_SRF(uint8_t pinTrig, uint8_t pinEcho):
                      _pinTrig(pinTrig), _pinEcho(pinEcho){
                              pinMode (_pinTrig,OUTPUT);
                              pinMode (_pinEcho,INPUT);
}

//#####################################################################################################
//###################  Metodi per l'utilizzo con gli interrupt  #######################################
//#####################################################################################################
/*
*comincia a trasmettere il segnale
*/

void Sonar_SRF:: sendSonar(){
 
  digitalWrite(_pinTrig, LOW);
  delayMicroseconds(2);
  digitalWrite(_pinTrig, HIGH);
  delayMicroseconds(10);
  digitalWrite(_pinTrig, LOW);
}


/*
*calcola la distanza convertendo il tempo ricevuto
*/

void Sonar_SRF::calcDistance(){  
  if(digitalRead(_pinEcho)==HIGH)
    _val=micros();
  if(digitalRead(_pinEcho)==LOW)
    _distanceCm=(micros() - _val) / 29.1 / 2;     
}


/*
*ritorna la misura
*
*ATTENZIONE: utilizza la misura salvata nella variabile, quindi se l'interrupt non ha fatto
*a tempo a tornare restituisce una variabile del giro precedente
*/

long Sonar_SRF::getDistance(){
  return _distanceCm;
}


/*
*oggetto su cui lavorano gli interrupt
*/
Sonar_SRF sonarInterrupt=Sonar_SRF(12,2,0);


/*
*chiama la funzione calcDistance dell'oggetto sonar
*è necessaria perchè gli interrupt devono chiamare funzioni non riferite a oggetti
*/
void calcDist(){
  sonarInterrupt.calcDistance(); 
}

//#####################################################################################################
//###################  Metodi per l'utilizzo con gli interrupt  #######################################
//#####################################################################################################

/*
*calcola distanza e la stampa
*/
void Sonar_SRF::duration(){
  digitalWrite(_pinTrig, LOW);
  delayMicroseconds(2);
  digitalWrite(_pinTrig, HIGH);
  delayMicroseconds(10);
  digitalWrite(_pinTrig, LOW);
  _duration = pulseIn(_pinEcho,HIGH);
  _distanceCm = _duration / 29.1 / 2 ;
  
  if (_distanceCm <= 0){
    Serial.println("Out of range");
  }
  else {
    Serial.print(_distanceCm);
    Serial.print("cm");
    Serial.println();
  }
  delay(1000);
} 
