#ifndef SONAR_SRF_H_
#define SONAR_SRF_H_

#include <inttypes.h>
#include <arduino.h>

class Sonar_SRF{
  public:
  Sonar_SRF(uint8_t pinTrig, uint8_t pinEcho, bool interrupt);
  Sonar_SRF(uint8_t pinTrig, uint8_t pinEcho);
  
  void calcDistance();
  long getDistance();
  void sendSonar();
  void duration();
  
  
  private:
  long _duration;
  long _distanceCm;
  long _distanceIn;
  const uint8_t _pinTrig;
  const uint8_t _pinEcho;
  volatile unsigned long _val;
};

extern Sonar_SRF sonarInterrupt;      //crea un oggetto da istanziare nel cpp, ma visibile nel main


#endif /*SONAR_SRF_H_*/
